<script>
import {useStore} from "vuex";
import EventBus from '@/utils/event-bus.js';
import {HOST_API} from "@/vars";

export default {
  name: 'MenuProjects',
  setup() {
    const store = useStore()
    return {
      store,
    }
  },
  data: () => ({
    projects: null,
    role: null,
    roles: ["admin", "writer"]
  }),
  computed: {
    isPermittedAction() {
      if (this.role) {
        return this.roles.includes(this.role)
      }
    },
  },
  async mounted() {
    this.role = this.store.state.profile.role
    let instance = this;
    EventBus.on('updated-project', function (data) {
      if (data) {
        instance.getProjectsCount()
      }
    })
  },
  async created() {
    await this.getProjectsCount()
  },
  methods: {
    async getProjectsCount() {
      const response = await fetch(HOST_API + '/projects/count/', {
        method: 'GET',
        headers: {
          'Content-Type': 'application/json',
          'Authorization': `Bearer ${this.store.state.authentication.access}`,
        }
      })
      this.projects = await response.json()
    }
  }
}
</script>

<template>
  <div class="col-12 lg:col-12 xl:col-12 mb-0 pb-0" style="position:relative; height: 50px">
    <h5 class="mb-0">Proyectos</h5>
    <router-link v-if="isPermittedAction"
                 :to="{name: 'project_create'}"
                 class="p-button p-component p-button-outlined p-button-secondary mr-2 mb-2"
                 style="position: absolute; right: 10px; top: 10px"
    >
      Crear proyecto
    </router-link>
  </div>
  <div class="col-12 lg:col-6 xl:col-3" v-if="projects && projects.hasOwnProperty('qualified')">
    <div class="card mb-0">
      <div class="flex justify-content-between mb-3">
        <div>
          <span class="block text-500 font-medium mb-3">Calificados</span>
          <div class="text-900 font-medium text-xl">{{ projects.qualified }}</div>
        </div>
        <div class="flex align-items-center justify-content-center bg-blue-100 border-round"
             style="width: 2.5rem; height: 2.5rem">
          <i class="pi pi-check-circle text-blue-500 text-xl"></i>
        </div>
      </div>
      <router-link :to="{ name: 'project_list', params: {'status': 'qualified'}}" class="text-green-500 font-medium">
        Ver
      </router-link>
    </div>
  </div>
  <div class="col-12 lg:col-6 xl:col-3" v-if="projects && projects.hasOwnProperty('send')">
    <div class="card mb-0">
      <div class="flex justify-content-between mb-3">
        <div>
          <span class="block text-500 font-medium mb-3">Por calificar</span>
          <div class="text-900 font-medium text-xl">{{ projects.send }}</div>
        </div>
        <div class="flex align-items-center justify-content-center bg-orange-100 border-round"
             style="width: 2.5rem; height: 2.5rem">
          <i class="pi pi-eye text-orange-500 text-xl"></i>
        </div>
      </div>
      <router-link :to="{ name: 'project_list', params: {'status': 'review'}}" class="text-green-500 font-medium">Ver
      </router-link>
    </div>
  </div>
  <div class="col-12 lg:col-6 xl:col-3" v-if="projects && projects.hasOwnProperty('not_qualifier')">
    <div class="card mb-0">
      <div class="flex justify-content-between mb-3">
        <div>
          <span class="block text-500 font-medium mb-3">Sin calificador</span>
          <div class="text-900 font-medium text-xl">{{ projects.not_qualifier }}</div>
        </div>
        <div class="flex align-items-center justify-content-center bg-cyan-100 border-round"
             style="width: 2.5rem; height: 2.5rem">
          <i class="pi pi-info-circle text-cyan-500 text-xl"></i>
        </div>
      </div>
      <router-link :to="{ name: 'project_list', params: {'status': 'not-qualifier'}}"
                   class="text-green-500 font-medium">Ver
      </router-link>
    </div>
  </div>
  <div class="col-12 lg:col-6 xl:col-3" v-if="projects && projects.hasOwnProperty('draft')">
    <div class="card mb-0">
      <div class="flex justify-content-between mb-3">
        <div>
          <span class="block text-500 font-medium mb-3">En borrador</span>
          <div class="text-900 font-medium text-xl">{{ projects.draft }}</div>
        </div>
        <div class="flex align-items-center justify-content-center bg-purple-100 border-round"
             style="width: 2.5rem; height: 2.5rem">
          <i class="pi pi-eraser text-purple-500 text-xl"></i>
        </div>
      </div>
      <router-link :to="{ name: 'project_list', params: {'status': 'draft'}}" class="text-green-500 font-medium">Ver
      </router-link>
    </div>
  </div>
</template>

<style lang="scss" scoped></style>